-- ######################  CONFIGURATION ####################################

function MasterCommanderConfig_LoadVars()
	-- initialize our SavedVariable
	if ( not MasterCommanderConfig ) then 
	 	MasterCommanderConfig = {}; 
	end

	-- LOAD CHARACTER
	if ( not MasterCommanderConfig[MasterCommanderRealm] ) then 
	 	MasterCommanderConfig[MasterCommanderRealm] = {}; 
	end
	if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar] ) then 
	 	MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar] = {}; 
	end

	-- CHECK OPTIONS
	
	-- load each option, set default if not there
	
		-- Channel
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel ) then 
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel = MasterCommander_Conf_Channel;
		end
		
		
		-- Warning messages
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid = MasterCommander_Conf_TauntResistAnnounceToRaid;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid = MasterCommander_Conf_TauntResistSayInRaid;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay = MasterCommander_Conf_TauntResistSayInSay;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel = MasterCommander_Conf_TauntResistPaladinChannel;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInRaid = MasterCommander_Conf_TauntedSayInRaid;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInSay = MasterCommander_Conf_TauntedSayInSay;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikeSayInSay ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikeSayInSay = MasterCommander_Conf_CrusaderStrikeSayInSay;
		end
		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel = MasterCommander_Conf_CrusaderStrikePaladinChannel;
		end

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionSayInRaid ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel = MasterCommander_Conf_DivineInterventionSayInRaid;
		end	

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionPaladinChannel ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel = MasterCommander_Conf_DivineInterventionPaladinChannel;
		end	
		
		
		-- HUD Visibility		
		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudOutCombat ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudOutCombat = MasterCommander_Conf_HudOutCombat;
		end	

		if ( not MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudInCombat ) then
			MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudInCombat = MasterCommander_Conf_HudInCombat;
		end			
		
		

	-- record that we have been loaded
	MasterCommander_variablesLoaded = true;

	
	MasterCommanderConfig_Change();

end

 function MasterCommanderConfig_Change()

	-- check vars loaded
	if ( not MasterCommander_variablesLoaded ) then -- config not loaded
		ConfigFrame:Hide(); -- turn our mod off
		return;
	end
	
	-- make sure to use the frame's name here, cannot rely on 'this' to mean the main frame
	if ( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].on ) then
		ConfigFrame:Show(); -- show our mod frame
	else
		ConfigFrame:Hide(); -- hide our mod frame
	end
 end


function MasterCommanderConfigFrame_OnShow()

	-- make sure our profile has been loaded
	if ( not MasterCommander_variablesLoaded ) then -- config not loaded
		ConfigFrame:Hide(); -- hide our config pane
		return;
	end
	
	-- read settings from profile, and change our checkbuttons and slider to represent them
	
	
	-- PALADIN CHANNEL
		PaladinChannel:SetText(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].Channel);
	
	-- WARNING MESSAGES
	
		TauntResistAnnounceToRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistAnnounceToRaid );
		TauntResistSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInRaid );
		TauntResistSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistSayInSay );
		TauntResistPaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntResistPaladinChannel );
		TauntedSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInRaid );
		TauntedSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].TauntedSayInSay );
		CrusaderStrikeSayInSay:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikeSayInSay );
		CrusaderStrikePaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].CrusaderStrikePaladinChannel );
		DivineInterventionSayInRaid:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionSayInRaid );
		DivineInterventionPaladinChannel:SetChecked( MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].DivineInterventionPaladinChannel);				
		
	-- HUD VISIBILITY
		HudInCombat:SetValue(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudInCombat);
		HudOutCombat:SetValue(MasterCommanderConfig[MasterCommanderRealm][MasterCommanderChar].HudOutCombat);
								
		
end


-- ####################### HUD VISIBILITY ###################################

function SetHudVisibilityUp()
		
		local var_HudInCombat = HudInCombat:GetValue();
			if(var_HudInCombat == 0) then
				ProtectorFrame:Hide();
			else
				ProtectorFrame:Show();
				local var_HudInCombat2 = var_HudInCombat / 100;
				ProtectorFrame:SetAlpha(var_HudInCombat2);
			end		
end

function SetHudVisibilityDown()
		local var_HudOutCombat = HudOutCombat:GetValue();
			if(var_HudOutCombat == 0) then
				ProtectorFrame:Hide();
			else
				ProtectorFrame:Show();
				local var_HudOutCombat2 = var_HudOutCombat / 100;
				ProtectorFrame:SetAlpha(var_HudOutCombat2);
			end
end



Hud_UpdateInterval = 4;
function SetHudVisibilityUpdate(elapsed)
  TimeSinceLastUpdate2 = TimeSinceLastUpdate2 + elapsed; 	

  while (TimeSinceLastUpdate2 > Hud_UpdateInterval) do
    --
    -- Insert your OnUpdate code here
	
		SetHudVisibilityDown();

	
    --

    TimeSinceLastUpdate2 = TimeSinceLastUpdate2 - Hud_UpdateInterval;
  end
end				
				
-- ####################### ON LOAD EVENTS ###################################

function CheckAD_OnLoad()
	checkad = 0;

	local numTabs = GetNumTalentTabs();
	for t=1, numTabs do
		local numTalents = GetNumTalents(t);
		for i=1, numTalents do
			spell, icon, tier, column, currRank, maxRank= GetTalentInfo(2,19);  -- Tree 3 (protection), tier 19
		end
	end

	  if (spell == "Ardent Defender" and currRank > 0) then
		 checkad = 1;
	  end
		  
	return checkad;

end

function Check_SpellID(name)
	local i = 1
	while true do
	   local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
	   if not spellName then
		  do break end
	   end
	   
	   if(spellName == name) then
			MC_spellid = i;
			return MC_spellid;
		end
	   
	   i = i + 1
	end
	
	
end


-- ####################### ON EVENT #############################
function MasterCommander_initialize()
	-- add our very first chat command!
	
	DEFAULT_CHAT_FRAME:AddMessage('** Master and Commander loaded. Version 0.10 **');
	DEFAULT_CHAT_FRAME:AddMessage('** |cffff0000-- Alpha version, contains only a tauntaddon for the moment --|r **');
	
	-- slashcommands to start MasterCommander Tankframe
	SlashCmdList["ACTIVATION"] = MasterCommander_Activation;
	SLASH_ACTIVATION1 = "/MasterAndCommander";
	SLASH_ACTIVATION2 = "/mac";
	
	SlashCmdList["CONFIGURATION"] = MasterCommander_ShowConfigration;
	SLASH_CONFIGURATION1	= "/MasterAndCommander_Config";
	SLASH_CONFIGURATION2	= "/macconfig";
	
	SlashCmdList["CDANCE"] = MasterCommander_Dance;
	SLASH_CDANCE1 = "/cdance";
	SLASH_CDANCE2 = "/macdance";

	
end


 -- ------------------------------------------------
function out(text)
 UIErrorsFrame:AddMessage(text, 1.0, 1.0, 1.0, 1, 10) 
end

function out_error(text)
 UIErrorsFrame:AddMessage(text, 1.0, 0.0, 0, 1, 10) 
end


function MasterCommander_Dance()
	if(UnitName("target")) then
	
		t = { 
			"%T, Dance with me baby!",
			"Hey %T lovecrusader, I want to be your spaceinvader!",
			"Hey %T, ride with me away!"
		}
	else
		t = { 
			"1",
			"2",
			"3"
		}
	end
	
	DoEmote("DANCE", ""); 
	rand_number = math.random(1, getn(t));
	
	SendChatMessage((t[rand_number]) , "SAY", nil, index);
end


function MasterCommander_ShowConfigration()
   local frame = getglobal("ConfigFrame");
   if (frame) then
		 if(  frame:IsVisible() ) then
		   frame:Hide();
		else
			frame:Show();
		end
   end

end

function MasterCommander_Activation()

   local frame = getglobal("MasterCommanderFrame");
   if (frame) then
 	 if(  frame:IsVisible() ) then
   	   frame:Hide();
  	else
    	frame:Show();
  	end
   end


		-- Calculate percentage of the target's total health
		local max_health = UnitHealthMax("target");
		local current_health = UnitHealth("target");
		local health_now = math.ceil((100 / max_health) * current_health, 0);
		-- SendChatMessage('%T\'s health: ' .. health_now.. "%" , "SAY", nil, index); 
	
end



-- ############ STATIC FUNCTIONS ##################### 

-- Check Ardent Defender activity 
function CheckAD_OnHealth()

		local max_health = UnitHealthMax("player");
		local current_health = UnitHealth("player");
		local health_now = (100 / max_health) * current_health;
					
		if (health_now > 20) then
			ADefender:SetText('shield inactive');
			TextureAdOFF:SetAlpha(1);
			TextureAdON:SetAlpha(0);
		else
			ADefender:SetText('|r |cffff0000shield activated|r');
			TextureAdOFF:SetAlpha(0);
			TextureAdON:SetAlpha(1);
		end
		
end



-- Spellcasting and return to enemy


-- ModelFrame updater
		function ModelFrame_OnEvent(hide)
		if not UnitExists("target") then
			ModelFrame:ClearModel();
		end

		ModelFrame:SetUnit("target");
		ModelFrame:SetAlpha(0.92);
		ModelFrame:SetScale(1);
		ModelFrame:SetCamera(0);
		ModelFrame:SetFacing(-45);
		ModelFrame:SetPosition(0,0,-1);
		ModelFrame:SetLight(1, 0, 0, -0.707, -0.707, 0.7, 1.0, 1.0, 1.0, 0.8, 1.0, 1.0, 0.8);

end






-- ######################## ON UPDATE EVENTS ############################### --


UnitHealth_UpdateInterval = 0.05;

function UnitHealth_OnUpdate(elapsed)
  TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	
  
  Needed_Debuffs_OnUpdate();

  while (TimeSinceLastUpdate > UnitHealth_UpdateInterval) do
    --
    -- Insert your OnUpdate code here
		if(UnitName("target")) then
				local max_health = UnitHealthMax("target");
				local current_health = UnitHealth("target");
				local health_now = math.ceil((100 / max_health) * current_health, 0);
				if(health_now == 0) then
					TargetHealthUnit:SetText('dead');
				else
					TargetHealthUnit:SetText(UnitName("target")..' ('..health_now..'% )');
				end
		else
			TargetHealthUnit:SetText('-');
		end
	
    --

    TimeSinceLastUpdate = TimeSinceLastUpdate - UnitHealth_UpdateInterval;
  end
end




PlayerMana_UpdateInterval = 5;

function PlayerMana_OnUpdate(elapsed)
  TimeSinceLastUpdate3 = TimeSinceLastUpdate3 + elapsed; 	

  while (TimeSinceLastUpdate3 > PlayerMana_UpdateInterval) do
    --
    -- Insert your OnUpdate code here

	if(lastmana) then
		if(lastmana > UnitMana("player")) then
			ManaNow = lastmana - UnitMana("player");
			Percentage = (100 * (lastmana - UnitMana("player"))) / UnitManaMax("player");
			if(Percentage > 8.33) then
				clr = '|cFFFF0000';
			else
				clr = '|cFFFFFFFF';
				if(Percentage > 5) then
					clr = '|cFFF77F1D';
				end
			end

			manaout = clr.."-"..ManaNow..'(%'.. math.ceil( Percentage )..')';
		else
			if(lastmana < UnitMana("player")) then
				ManaNow = UnitMana("player") - lastmana;
				Percentage = (100 * (UnitMana("player") - lastmana)) / UnitManaMax("player");
				manaout = "|cFF6DCFF6+"..ManaNow..'(%'..math.ceil(Percentage)..')';
			else

			end
		end
		
		if(lastmana == UnitMana("player")) then
			manaout = '|cFFFFFFFF0';
		end
		
		lastmana = UnitMana("player");
		
		ManausageText:SetText(manaout);

	else
		lastmana = UnitMana("player");
	end

    --

    TimeSinceLastUpdate3 = TimeSinceLastUpdate3 - PlayerMana_UpdateInterval;
  end
end




-- cehck targets & switches for highlighting / activating taunt button

function CheckTargets_OnUpdate(spell_ID)

			check = 0;

			if( not UnitIsDeadOrGhost("target") == 1 ) then
			else
		
				if ( UnitIsPlayer("target")  == 1 or UnitIsFriend("player","target")) then
				else
						if(UnitName("targettarget")) then
							if(not (UnitName("targettarget") == UnitName("target")) ) then
							
								local targetTargetName = UnitName("targettarget");
								local targetName = UnitName("target");
								local ownName = UnitName("player");
				
								if(not (targetTargetName == ownName) ) then
									local start, duration = GetSpellCooldown(spell_ID, BOOKTYPE_SPELL);
									if ( start > 0 and duration > 0) then
									else
										check = 1;
										CastTaunt();
									end
								end
							end	
						end
				end
			end
			
			e_button = getglobal("Taunt_Button_Enable");
			d_button = getglobal("Taunt_Button_Disable");	
			
			if ( check == 1) then
				e_button:Show();
				d_button:Hide();
			end
			
			if ( check == 0) then
				e_button:Hide();
				d_button:Show();
			end

end


-- COMBAT MESSAGES

function Msg_Miss(arg1)
	if( string.find(arg1, "parry", 1))  then
		DEFAULT_CHAT_FRAME:AddMessage('Parried!');
	end
	
	if( string.find(arg1, "dodge", 1))  then
		DEFAULT_CHAT_FRAME:AddMessage('Dodged!');
	end
	
		if( string.find(arg1, "misses", 1))  then
		DEFAULT_CHAT_FRAME:AddMessage('Missed!');
	end
	
	if( string.find(arg1, "BLOCK", 1))  then
		DEFAULT_CHAT_FRAME:AddMessage('Blocked!');
	end
	
		if( string.find(arg1, "RESIST", 1))  then
		DEFAULT_CHAT_FRAME:AddMessage('Resisted!');
	end
	
end

function Msg_MissEnemy(arg1)
	
	-- initialize paladin channel
	local var_PaladinChannel = PaladinChannel:GetText();
	
	-- initialize warnings	(crusader strike)
	local var_CrusaderStrikePaladinChannel = CrusaderStrikePaladinChannel:GetChecked();
	local var_CrusaderStrikeSayInSay = CrusaderStrikeSayInSay:GetChecked();
	
	-- initialize warnings	(righteous defense)
	local var_TauntResistAnnounceToRaid = TauntResistAnnounceToRaid:GetChecked();
	local var_TauntResistSayInRaid = TauntResistSayInRaid:GetChecked();	
	
	local var_TauntResistPaladinChannel = TauntResistPaladinChannel:GetChecked();
	local var_TauntResistSayInSay = TauntResistSayInSay:GetChecked();	
	
	local var_TauntedSayInRaid = TauntedSayInRaid:GetChecked();
	local var_TauntedSayInSay = TauntedSayInSay:GetChecked();
	
	-- Warnings
	
	cmissed = 0;
	missed = 0;
	spell1 = 'Crusader Strike';
	spell2 = 'Righteous Defense';
	
	if( string.find(arg1, spell1, 1))  then
		if( string.find(arg1, "resisted", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "parried", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "dodged", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "missed", 1))  then
			cmissed = 1;
		end
		if( string.find(arg1, "blocked", 1))  then
			cmissed = 1;
		end				
		if( string.find(arg1, "immune", 1))  then
			cmissed = 1;
		end	
	else
		cmissed = 0;
	end	

	if( string.find(arg1, spell1, 1))  then
			if(cmissed == 1) then
				if(var_CrusaderStrikeSayInSay == 1) then
					SendChatMessage('Crusader Strike not applied!' , "SAY", nil, index);
				end
				if(var_CrusaderStrikePaladinChannel == 1) then
					local PalaChannel = GetChannelName(var_PaladinChannel) ;
					SendChatMessage('Crusader Strike not applied!' , "CHANNEL", nil, PalaChannel); 
				end					
			end
	end

	
	if( string.find(arg1, spell2, 1))  then
		if( string.find(arg1, "resisted", 1))  then
			missed = 1;
		end
		if( string.find(arg1, "parried", 1))  then
			missed = 1;
		end
		if( string.find(arg1, "dodged", 1))  then
			missed = 1;
		end
		if( string.find(arg1, "missed", 1))  then
			missed = 1;
		end	
		if( string.find(arg1, "immune", 1))  then
			missed = 1;
		end
	else
		missed = 0;
	end	
		
		
	if( string.find(arg1, spell2, 1))  then	
	

	
			if(missed == 1) then
				if(var_TauntResistAnnounceToRaid == 1) then
					SendChatMessage(UnitName("player").."'s taunt got resisted!" , "RAID_WARNING", nil, index); 
				end
				
				if(var_TauntResistSayInRaid == 1) then
					var_party = 0; 
					var_raid = 0;
					
					if(UnitInParty("player") == 1) then
						var_party = 1;			
							if(UnitInRaid("player") == 1) then
								var_raid = 1;
							end					
					end
					
					if(var_raid == 1) then
						SendChatMessage(UnitName("player").."'s taunt got resisted!" , "RAID", nil, index); 
					else
						if(var_party == 1) then
							SendChatMessage(UnitName("player").."'s taunt got resisted!" , "PARTY", nil, index); 
						end
					end						
				end	
				
				if(var_TauntResistSayInSay == 1) then
					SendChatMessage(UnitName("player").."'s taunt got resisted!" , "SAY", nil, index);
				end
				
				if(var_TauntResistPaladinChannel == 1) then
					local PalaChannel = GetChannelName(var_PaladinChannel) ;
					SendChatMessage(UnitName("player").."'s taunt resisted!" , "CHANNEL", nil, PalaChannel); 
				end					
			else


				string = string.sub(arg1, 30);
				
				if(var_TauntedSayInRaid == 1) then
					var_party = 0; 
					var_raid= 0;
					if(UnitInParty("player") == 1) then
						var_party = 1;			
							if(UnitInRaid("player") == 1) then
								var_raid = 1;
							end
					end
					
					
					
					if(var_raid == 1) then
						SendChatMessage(UnitName("player")..' has taunted'..string , "RAID", nil, index); 
					else
						if(var_party == 1) then
							SendChatMessage(UnitName("player")..' has taunted'..string , "PARTY", nil, index); 
						end
					end							
				end
				
				if(var_TauntedSayInSay == 1) then
					SendChatMessage(UnitName("player")..' has taunted'..string , "SAY", nil, index);
				end									
			end
	end




end


function Msg_DivineIntervention(arg1)

	local var_DivineInterventionSayInRaid = DivineInterventionSayInRaid:GetChecked();
	local var_DivineInterventionPaladinChannel = DivineInterventionPaladinChannel:GetChecked();
	local var_PaladinChannel = PaladinChannel:GetText();
				
	if( string.find(arg1, "You cast Divine Intervention on", 1))  then
		local str_playername = string.sub(arg1, 32);
		
		if(var_DivineInterventionSayInRaid == 1) then
			var_party = 0; 
			var_raid= 0;
			if(UnitInParty("player") == 1) then
				var_party = 1;			
					if(UnitInRaid("player") == 1) then
						var_raid = 1;
					end
			end
			
			if(var_raid == 1) then
				SendChatMessage('Divine Intervention on'..str_playername , "RAID", nil, index); 
			else
				if(var_party == 1) then
					SendChatMessage('Divine Intervention on'..str_playername , "PARTY", nil, index); 
				end
			end							
		end
		
		if(var_DivineInterventionPaladinChannel == 1) then
			local PalaChannel = GetChannelName(var_PaladinChannel);
			SendChatMessage(UnitName("player")..' casted Divine Intervention on'..str_playername , "CHANNEL", nil, PalaChannel); 	
		end
	end	
end



-- library thingies

	-- PlaySound("PVPENTERQUEUE"); // Sound for successfull agro
	-- PlaySoundFile("Interface\\AddOns\\MasterCommander\sleep_rest.mp3");